#pragma once

namespace MHook_Hooks {
	uint64_t hookSmall(void);
	uint64_t hookBranch(uint64_t);
	uint64_t hookRip_relative(void);
	void _AVX(float num, void* res);
	uint32_t _RDRAND(void);
};

class MHook : public AbstractHookEngine {
public:
	bool hook_all();
	bool unhook_all();

	MHook() : AbstractHookEngine("MHook") {

	}

	friend uint64_t MHook_Hooks::hookSmall(void);
	friend uint64_t MHook_Hooks::hookBranch(uint64_t);
	friend uint64_t MHook_Hooks::hookRip_relative(void);
	
	friend void MHook_Hooks::_AVX(float num, void* res);
	friend uint32_t MHook_Hooks::_RDRAND(void);
};